package com.wizarpos.mdbtest;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.TextView;

import com.cloudpos.DeviceException;
import com.cloudpos.OperationListener;
import com.cloudpos.OperationResult;
import com.cloudpos.POSTerminal;
import com.cloudpos.TimeConstants;
import com.cloudpos.card.Card;
import com.cloudpos.rfcardreader.RFCardReaderDevice;
import com.cloudpos.rfcardreader.RFCardReaderOperationResult;
import com.cloudpos.serialport.SerialPortDevice;
import com.cloudpos.serialport.SerialPortOperationResult;
import com.cloudpos.smartcardreader.SmartCardReaderDevice;
import com.wizarpos.util.ByteConvertStringUtil;
import com.wizarpos.util.LogHelper;
import com.wizarpos.util.MDBUtils;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigInteger;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;

public class MainActivity extends Activity implements View.OnClickListener, SettingDialog.OnDialogClickListener {
    private TextView textView, progress_textView;
    private EditText input;
    private Button openBtn, sendBtn, closeBtn, btnGetVersion, btnDownloadFw, startBtn, btnSetting;
    private Spinner spn_white_demon; //spnTriggerPulse
    private String spnItemWhiteDemon; //spnItemTriggerPulse
    private static final String TAG = "MDB TAG";
    private int currentSend;
//    private int frequency, balance, latency;
    private String currentVersion = "";
    private SerialPortDevice device;

    private final int BLACK_LOG = 1;
    private final int RED_LOG = 2;
    private final int GREEN_LOG = 4;
    private final int DIALOG_CONFIRM = 8;
    private final int DIALOG_SET_PULSE = 9;
    private final int DIALOG_ITEM = 10;
    private final int DIALOG_READCARD = 11;
    private final int ENABLE_ALL_BUTTON = 15;
    private final int DISABLE_ALL_BUTTON = 16;
    private final int DISABLE_UPDATE_BUTTON = 17;
    private final int ENABLE_UPDATE_BUTTON = 18;


//    public boolean isSlave = false;
    private ProgressBar progress;

    private Context context;

    SettingDialog settingDialog;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        textView = (TextView) findViewById(R.id.textviewaa);
        progress_textView = (TextView) findViewById(R.id.progress_textView);

        input = (EditText) findViewById(R.id.input);


        progress = (ProgressBar) findViewById(R.id.progress);

        spn_white_demon = (Spinner) findViewById(R.id.spn_white_demon);
//        spnTriggerPulse = (Spinner) findViewById(R.id.spn_pulse_frequency);


        textView.setMovementMethod(ScrollingMovementMethod.getInstance());

        openBtn = (Button) findViewById(R.id.open);
        sendBtn = (Button) findViewById(R.id.btn_test_send);
        closeBtn = (Button) findViewById(R.id.close);
        startBtn = (Button) findViewById(R.id.btn_start);
        btnGetVersion = (Button) findViewById(R.id.btn_get_version);
        btnDownloadFw = (Button) findViewById(R.id.btn_download_fw);
        btnSetting = (Button) findViewById(R.id.btn_setting);

        openBtn.setOnClickListener(this);
        sendBtn.setOnClickListener(this);
        closeBtn.setOnClickListener(this);
        startBtn.setOnClickListener(this);
        btnGetVersion.setOnClickListener(this);
        btnDownloadFw.setOnClickListener(this);
        btnSetting.setOnClickListener(this);

        makeSpinner();
        context = this;
        open();
    }

    public void makeSpinner(){
        ArrayAdapter<CharSequence> adapterWhiteDemon = ArrayAdapter.createFromResource(this,
                R.array.white_demon, android.R.layout.simple_spinner_item);
        adapterWhiteDemon.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spn_white_demon.setAdapter(adapterWhiteDemon);
        spn_white_demon.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                spnItemWhiteDemon = spn_white_demon.getSelectedItem().toString();
            }
            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
        /*
        ArrayAdapter<CharSequence> adapterFrequency = ArrayAdapter.createFromResource(this,
                R.array.trigger_pulse, android.R.layout.simple_spinner_item);
        adapterFrequency.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spnTriggerPulse.setAdapter(adapterFrequency);
        spnTriggerPulse.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                spnTriggerPulseItem = spnTriggerPulse.getSelectedItem().toString();
            }
            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
        */
    }

    void open() {
        device = (SerialPortDevice) POSTerminal.getInstance(this).getDevice("cloudpos.device.serialport");
        try {
            device.open(2);
        } catch (DeviceException e){
            Log.d(TAG, "SerialPort open failed");
            e.printStackTrace();
            return;
        }
        try {
            device.changeSerialPortParams(115200, 3, 0, 0);
        }catch (DeviceException e){
            Log.d(TAG, "set baudrate failed");
            e.printStackTrace();
            return;
        }
        SystemClock.sleep(100);
        handler.obtainMessage(BLACK_LOG, "seriaport open success!").sendToTarget();
//           if(isSlave)
        testMdbSlaveRead();
    }

    void close() {
        try {
            device.close();
        } catch (DeviceException e){
            Log.d(TAG, "SerialPort close failed");
            e.printStackTrace();
            return;
        }
        handler.obtainMessage(BLACK_LOG, "seriaport close success").sendToTarget();
    }

    public byte[] read(byte[] byteArr, int length, int timeout){
        try{
            while(true) {
                SerialPortOperationResult serialPortOperationResult = device.waitForRead(length, timeout);
                byte[] data = serialPortOperationResult.getData();
                int datalength = serialPortOperationResult.getDataLength();
                byteArr = subByteArray(data, datalength);
                if(byteArr.length > 0)
                    break;
            }
        } catch (DeviceException e) {
			throw new RuntimeException(e);
		}
        return byteArr;
	}



    public void testMdbSlaveRead() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                Item item = new Item();
                handler.obtainMessage(BLACK_LOG, "Init, waiting master command...").sendToTarget();
//                while (isSlave) {
                while (true) {
                    byte[] byteArr = new byte[1];
                    // read start flag 0x09, 1 bit
                    byteArr = read(byteArr, byteArr.length, 1000);
                    if(ByteConvertStringUtil.buf2StringCompact(byteArr).equals("0D")){
                        continue;
                    }
                    String sp = "";
                    if (byteArr.length >= 0) {
                        if (ByteConvertStringUtil.buf2StringCompact(byteArr).equals("09")) {
                            // read data length, 1 bit
                            byteArr = read(byteArr, byteArr.length, 200);
                            if (byteArr.length > 0) {
                                String lenthHex = ByteConvertStringUtil.buf2StringCompact(byteArr);
                                BigInteger length = new BigInteger(lenthHex, 16);
                                // read data
                                byteArr = new byte[length.intValue()];
                                byteArr = read(byteArr, byteArr.length, 200);
                                if (byteArr.length > 0) {
                                    String stringCompact = ByteConvertStringUtil.buf2StringCompact(byteArr);
                                    Log.d(TAG, "read success: " + stringCompact);
                                    sp = stringCompact;
                                } else {
                                    Log.d(TAG, "read failed");
                                }
                            }
                            if (sp.startsWith("01 20 00")){
//                                Log.i(TAG, "receive");
                                //receive: 09 04 01 20 00 DF 0D
                                int latency = Integer.parseInt(settingDialog.getLatency());
                                SystemClock.sleep(latency);
                                int frequency = Integer.parseInt(settingDialog.getFrequency());
                                if(currentSend == frequency - 1){
                                    handler.obtainMessage(BLACK_LOG, "trigger pulse " + frequency + " times succeed").sendToTarget();
                                    handler.obtainMessage(ENABLE_ALL_BUTTON).sendToTarget();
                                }
                                if(currentSend < frequency - 1) {
                                    sendTriggerPulse();
//                                    Log.i(TAG, "send");
                                    ++currentSend;
                                }
                            }else {
                                processData(item, sp);
                            }
                        } else if(ByteConvertStringUtil.buf2StringCompact(byteArr).equals("0D")){
                            sp = "0D";
                        } else {
                            sp = "reading...";
                        }
                    }
//                    else if (readResult == -262254) {
//                        handler.obtainMessage(RED_LOG, "serialport read timeout").sendToTarget();
//                    } else {
//                        handler.obtainMessage(RED_LOG, "serialport read failed = " + readResult).sendToTarget();
//                    }
                    if (!sp.startsWith("01 20 00") && !sp.equals("0D")) {
                        SystemClock.sleep(500);
                    }
                }
//                close();
            }
        }).start();
    }

    private void processData(Item item, String sp){
        Log.i(TAG, sp + "  " + item.toString());
        if (sp.startsWith("00 10")) {
            if (sp.contains("00 10 10")) { // Reset
                sendReset();
            }
        } else if (sp.startsWith("00 11 00")) { //Setup config data
            sendSetupConfig(sp, item);
        } else if (sp.startsWith("00 11 01")) { // Setup Max/Min Price
            sendSetupPrice(sp);
        } else if (sp.startsWith("00 17 00")) { //Expansion ID
            sendExpansionID(sp);
        } else if (sp.startsWith("00 14 01") || sp.startsWith("00 14 00")) {//Enable Reader
            sendEnableReader(sp);
            startTransaction();
        } else if (sp.startsWith("01 00")) {
            handler.obtainMessage(BLACK_LOG, "Ready! Please input item ID").sendToTarget();
        } else if (sp.startsWith("00 15 00")){ //Revalue approved
            sendRevalueApproved(sp);
        } else if (sp.startsWith("00 15 01")){
            sendRevalueLimit(sp);
        } else if (sp.startsWith("00 13 00")) {
            item.setItemAmount(sp.substring(9, 15).replace(" ", ""));
            item.setItemId(sp.substring(15, 21).replace(" ", ""));
            item.calculatePrice();
            BigInteger itemid = new BigInteger(item.getItemId(), 16);
            item.setItemId(itemid.toString());
            handler.obtainMessage(DIALOG_READCARD, item).sendToTarget();
        } else if (sp.startsWith("00 13 02")) {
            sendDispatchSuccess(sp);
        } else if (sp.startsWith("00 13 04")) {
            sendSessionEnd(sp);
        } else if (sp.startsWith("00 14 02")){
            handler.obtainMessage(BLACK_LOG, "Reader cancelled").sendToTarget();
        } else if (sp.startsWith("01 90 03")) {
            handler.obtainMessage(BLACK_LOG, "set pulse duration succeed").sendToTarget();
        } else if (sp.startsWith("01 90 04")) {
            handler.obtainMessage(BLACK_LOG, "set pulse voltage succeed").sendToTarget();
        } else if (sp.startsWith("01 92 00")) {
            handler.obtainMessage(BLACK_LOG, "get result:" + sp).sendToTarget();
            printVersionName(sp);
        } else if (sp.equals("0D") || sp.equals("0d")){
            Log.d(TAG, "0D, end of data");
        } else if (sp.startsWith("00 13 01")) {  // by ruifeng.wan @20240124
            Log.d(TAG, "00 13 01, vending auto cancel, denied");
            sendVendDedied();
        } else {
            Log.d(TAG, "unknown data: " + sp);
            handler.obtainMessage(BLACK_LOG, "unknown data: " + sp).sendToTarget();
        }
        handler.obtainMessage(ENABLE_ALL_BUTTON).sendToTarget();
    }

    private void sendReset(){
        byte[] dataBytes = new byte[2];
        dataBytes[0] = 0;
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try {
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
			throw new RuntimeException(e);
		}
        Log.d(TAG, "Reset 0.0% " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "Reset 0.0%").sendToTarget();
    }
    //sp = "00 11 00 02 00 00 01 14"
    private void sendSetupConfig(String sp, Item item){
        byte[] dataBytes = new byte[9];
        dataBytes[0] = 0x01; //Reader Config Data
        String dataBytes1 = sp.substring(9, 11);
        byte dataByte1 = Byte.parseByte(dataBytes1);
        dataBytes[1] = dataByte1; //Reader Feature Level
        dataBytes[2] = 0x11; //Country Code High
        dataBytes[3] = (byte)0x56; // Country Code Low
        dataBytes[4] = 0x01; //Scale Factor (x when calculating price)
        item.setPriceX(Integer.toHexString(dataBytes[4]));
        dataBytes[5] = 0x02; //Decimal Places (y when calculating price)
        item.setPriceY(Integer.toHexString(dataBytes[5]));
        dataBytes[6] = 0x59; //Application Maximum Response Time
        dataBytes[7] = 0x0d; // Miscellaneous Options
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try {
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
			throw new RuntimeException(e);
		}
        Log.d(TAG, "Setup config data 20.0% " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "Setup config data 20.0%").sendToTarget();
    }
    private void sendSetupPrice(String sp){
        byte[] dataBytes = new byte[1];
        dataBytes[0] = 0;
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
			throw new RuntimeException(e);
		}
        Log.d(TAG, "Setup Max/Min Price 50.0% " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "Setup Max/Min Price 50.0%").sendToTarget();
    }
    //sp = "00 17 00 49 44 53 30 30 30 30 31 30 30 30 36 36 30 32 49 44 53 4d 44 42 56 4d 43 43 4f 4e 30 32 21"
    private void sendExpansionID(String sp){
        byte[] dataBytes = new byte[32];
        dataBytes[0] = 0x09; //Peripheral ID
        dataBytes[1] = 0x77;
        dataBytes[2] = 0x7a;
        dataBytes[3] = 0x70; //dataBytes[1-3]: Manufacturer Code
        dataBytes[4] = 0x00;
        dataBytes[5] = 0x00;
        dataBytes[6] = 0x00;
        dataBytes[7] = 0x00;
        dataBytes[8] = 0x00;
        dataBytes[9] = 0x00;
        dataBytes[10] = 0x00;
        dataBytes[11] = 0x00;
        dataBytes[12] = 0x00;
        dataBytes[13] = 0x00;
        dataBytes[14] = 0x00;
        dataBytes[15] = 0x00;//dataBytes[4-15]: Serial Number
        dataBytes[16] = 0x01;
        dataBytes[17] = 0x00;
        dataBytes[18] = 0x00;
        dataBytes[19] = 0x00;
        dataBytes[20] = 0x00;
        dataBytes[21] = 0x00;
        dataBytes[22] = 0x00;
        dataBytes[23] = 0x00;
        dataBytes[24] = 0x00;
        dataBytes[25] = 0x00;
        dataBytes[26] = 0x00;
        dataBytes[27] = 0x00;//dataBytes[16-27]: Model Number
        dataBytes[28] = 0x01;
        dataBytes[29] = 0x00;//dataBytes[28-29]: Software Version
        dataBytes[30] = 0x01;//Optional Feature bits
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
			throw new RuntimeException(e);
		}
        Log.d(TAG, "Expansion ID 60.0% " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "Expansion ID 60.0%").sendToTarget();
    }
    private void sendEnableReader(String sp){
        byte[] dataBytes = new byte[1];
        dataBytes[0] = 0;
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "Enable Reader 80.0% " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "Enable Reader 80.0%").sendToTarget();
    }
    private void sendRevalueApproved(String sp){
        byte[] dataBytes = new byte[1];
        dataBytes[0] = 0x0d;
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "Revalue approved 85% " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "Revalue approved 85%").sendToTarget();
    }
    private void sendRevalueLimit(String sp){
        byte[] dataBytes = new byte[4];
        dataBytes[0] = 0x0f; //Revalue Limit Amount
        dataBytes[1] = 0x27;
        dataBytes[2] = 0x10;//1-2: Revalue Limit Amount
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "Revalue limit request 90.0% " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "Revalue limit request 90.0%").sendToTarget();
    }
    private void sendDispatchSuccess(String sp){
        byte[] dataBytes = new byte[1];
        dataBytes[0] = 0;
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        String itemhex = sp.substring(9, 15).replace(" ", "");
        BigInteger itemid = new BigInteger(itemhex, 16);
        Log.d(TAG, "Dispatch success! " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(DIALOG_ITEM, "Dispatch success! item:" + itemid).sendToTarget();
    }
    private void sendSessionEnd(String sp){
        byte[] dataBytes = new byte[2];
        dataBytes[0] = 0x07; //End Session
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "finish. " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "finish.").sendToTarget();
        SystemClock.sleep(2000);
        startTransaction();
    }
    private void sendVendApproved(Item item){
        byte[] dataBytes = new byte[4];
        dataBytes[0] = 0x05;
        dataBytes[1] = (byte) Integer.parseInt(item.getItemAmount().substring(0,2), 16);
        dataBytes[2] = (byte) Integer.parseInt(item.getItemAmount().substring(2), 16);
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "approved! " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "approved!").sendToTarget();
    }
    private void sendVendDedied(){
        byte[] dataBytes = new byte[2];
        dataBytes[0] = 0x06;
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "denied! " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "denied!").sendToTarget();
    }
    //begin session
    private void startTransaction() {
        byte[] dataBytes = new byte[11];
        dataBytes[0] = 0x03; //Begin Session
        int balance = getBalance();
        if(balance < 0) {
            dataBytes[1] = 0x03;
            dataBytes[2] = (byte) 0xE8; //1-2: Funds/balance Available
        } else {
            dataBytes[1] = (byte)(balance >> 8 & 0xFF);
            dataBytes[2] = (byte)(balance & 0xFF);
        }
//        Log.i(TAG, " dataBytes[1] " + String.valueOf(dataBytes[1]) + " dataBytes[2] " + String.valueOf(dataBytes[2]));
//        Log.i(TAG, "balance : " + (dataBytes[1] << 8 | dataBytes[2]));
        dataBytes[3] = (byte)0xFF;
        dataBytes[4] = (byte)0xFF;
        dataBytes[5] = (byte)0xFF;
        dataBytes[6] = (byte)0xFF; //3-6: Payment media ID
        dataBytes[7] = (byte)0x00; //Payment Type
        dataBytes[8] = (byte)0x00;
        dataBytes[9] = (byte)0x00; //8-9: Payment Data
        dataBytes = MDBUtils.addMdbCheckSum(dataBytes);
        byte[] wbytes = MDBUtils.mergePacket(0, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "begin session " + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "begin session").sendToTarget();
    }
    private void sendReaderCancelled(String sp){
        byte[] dataBytes = new byte[1];
        dataBytes[0] = 0x08;
        byte[] wbytes = MDBUtils.mergePacket(1, dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "cancelled" + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "cancelled").sendToTarget();
    }
    private void sendTriggerPulse(){
        byte[] dataBytes = new byte[1];
        dataBytes[0] = 0x20;
        byte[] wbytes = MDBUtils.mergePacket(0,dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "send trigger pulse succeed !" + ByteConvertStringUtil.buf2StringCompact(wbytes));
    }
    private void sendSetPulseDuration(int duration){
        byte[] durationByte = new byte[2];
        durationByte[0] = (byte)(duration & 0xFF);
        durationByte[1] = (byte)((duration >> 8) & 0xFF);

        byte[] dataBytes = new byte[6];
        dataBytes[0] = (byte)0x90;
        dataBytes[1] = (byte)0x03;
        dataBytes[2] = durationByte[0];
        dataBytes[3] = durationByte[1]; //2-3: duration
        dataBytes[4] = (byte)0x00;
        dataBytes[5] = (byte)0x00;
        byte[] wbytes = MDBUtils.mergePacket(0,dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "send set pulse duration succeed !" + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "setting pulse duration").sendToTarget();
        SystemClock.sleep(200);
    }
    private void sendSetPulseVoltage(int voltage){
        byte[] voltageByte = new byte[2];
        voltageByte[0] = (byte)(voltage & 0xFF);
        voltageByte[1] = (byte)((voltage >> 8) & 0xFF);

        byte[] dataBytes = new byte[6];
        dataBytes[0] = (byte)0x90;
        dataBytes[1] = (byte)0x04;
        dataBytes[2] = voltageByte[0];
        dataBytes[3] = voltageByte[1]; //2-3: voltage
        dataBytes[4] = (byte)0x00;
        dataBytes[5] = (byte)0x00;
        byte[] wbytes = MDBUtils.mergePacket(0,dataBytes);
        try{
            device.write(wbytes, 0, wbytes.length);
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "send set pulse voltage succeed !" + ByteConvertStringUtil.buf2StringCompact(wbytes));
        handler.obtainMessage(BLACK_LOG, "setting pulse voltage").sendToTarget();
        SystemClock.sleep(200);
    }

    //09 06 01 92 00 00 0E 5F 0D
    private void sendVersionRequest() {
        byte[] wbytes = {0x09, 0x03, 0x00, (byte) 0x92, (byte) 0x6E, (byte) 0x0D};
        try{
            device.write(wbytes, 0, wbytes.length);
            handler.obtainMessage(BLACK_LOG, "Getting version, wait... ").sendToTarget();
        } catch (DeviceException e) {
            throw new RuntimeException(e);
        }
        Log.d(TAG, "send get version request succeed !" + ByteConvertStringUtil.buf2StringCompact(wbytes));
        SystemClock.sleep(200);
    }

    private void setPulse(){
        int duration = getPulseDuration();
        if(duration < 0){
            return;
        }
        int voltage = settingDialog.getVoltage();
        sendSetPulseDuration(duration);
        sendSetPulseVoltage(voltage);
    }


    private void testMdbMasterSend(){
        new Thread(new Runnable(){
            @Override
            public void run() {
                handler.obtainMessage(BLACK_LOG, "Init, sending reset request").sendToTarget();
                Log.d(TAG, "Init, sending reset request");
                boolean flagEnd = true;
//                int write = aaa.write(writeData, 0, writeData.length);
                boolean isPolled = false;
                byte[] resetRequest = createBytes();
                if(writeData(resetRequest)) {
                    boolean isReadReset = false;
                    boolean isReadSetupPrice = false;
                    boolean isReadEnableReader = false;
                    boolean isReadBeginSession = false;
                    boolean isReadVendDispatch = false;
                    boolean isReadConfig = false;
                    boolean isReadExpansionId = false;
                    boolean isReadVendApproved = false;
                    boolean isReadEnd = false;
                    boolean isWriteReset = false;
                    boolean isWriteSetupPrice = false;
                    boolean isWriteEnableReader = false;
                    boolean isWriteBeginSession = false;
                    boolean isWriteVendDispatch = false;
                    boolean isWriteConfig = false;
                    boolean isWriteExpansionId = false;
                    boolean isWriteVendApproved = false;
                    boolean isWriteEnd = false;
                    while (flagEnd) {
                        isPolled = false;
                        byte[] readResult = new byte[1];
                        readResult = read(readResult, readResult.length, 1000);
                        String sp = "";
                        if (readResult.length >= 0) {
                            if (ByteConvertStringUtil.buf2StringCompact(readResult).equals("09")) {
                                readResult = read(readResult, readResult.length, 500);
                                if (readResult.length > 0) {
                                    String lenthHex = ByteConvertStringUtil.buf2StringCompact(readResult);
                                    BigInteger item = new BigInteger(lenthHex, 16);
                                    readResult = new byte[item.intValue() + 1];
                                    readResult = read(readResult, readResult.length, 500);
                                    String stringCompact = ByteConvertStringUtil.buf2StringCompact(readResult);
                                    Log.d(TAG, "read success !!! read result : " + stringCompact);
                                    sp = stringCompact;
                                }
                            } else {
                                sp = "";
                                flagEnd = false;
                            }
                            if (sp.startsWith("01 00")) {
                                if(sp.equals("01 00 00 FF 0D")){
                                    isReadReset = true;
                                }
                                if (!isReadConfig && isReadReset) {
                                    //0011000200000114
                                    byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x11, 0x00, 0x02, 0x00, 0x00, 0x01, 0x14});
                                    if(isWriteConfig){
                                        writeData(createPollBytes());
                                    }else if (writeData(wbytes)) {
                                        handler.obtainMessage(BLACK_LOG, "sending setup config request").sendToTarget();
                                        isWriteConfig = true;
                                    }
                                }else if (!isReadExpansionId && isReadSetupPrice) {
                                    //0017004944533030303031303030363630324944534d4442564d43434f4e303221
                                    byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x17, 0x00, 0x49, 0x44, 0x53, 0x30, 0x30, 0x30, 0x30, 0x31, 0x30, 0x30, 0x30, 0x36, 0x36, 0x30,
                                            0x32, 0x49, 0x44, 0x53, 0x4D, 0x44, 0x42, 0x56, 0x4D, 0x43, 0x43, 0x4F, 0x4E, 0x30, 0x32, 0x21});
                                    if(isWriteExpansionId){
                                        writeData(createPollBytes());
                                    }else if (writeData(wbytes)) {
                                        handler.obtainMessage(BLACK_LOG, "sending Expansion ID request").sendToTarget();
                                        isWriteExpansionId = true;
                                    }
                                }else if (!isReadBeginSession && isReadEnableReader) {
                                    //00030064ffffffff00000063
//                                    byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x03, 0x00, 0x64, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF,
//                                            (byte) 0xFF, 0x00, 0x00, 0x00, 0x63});
//                                    if(isWriteBeginSession){
//                                        writeData(createPollBytes());
//                                    }else if (writeData(wbytes)) {
//                                        handler.obtainMessage(BLACK_LOG, "sending begin session with balance 0064 request").sendToTarget();
                                    isReadBeginSession = true;
                                    isWriteBeginSession = true;
//                                    }
                                }else if (!isReadVendApproved && isReadBeginSession) {
                                    //001300006400e158
                                    byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x13, 0x00, 0x00, 0x64, 0x00, (byte) 0xE1, 0x58});
                                    if(isWriteVendApproved){
                                        writeData(createPollBytes());
                                    }else if (writeData(wbytes)) {
                                        handler.obtainMessage(BLACK_LOG, "sending vend request with amount 0064").sendToTarget();
                                        isWriteVendApproved = true;
                                    }
                                }else if (!isReadEnd && isReadVendDispatch) {
                                    //00130417
                                    byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x13, 0x04, 0x17});
                                    if(isWriteEnd){
                                        writeData(createPollBytes());
                                    }else if (writeData(wbytes)) {
                                        handler.obtainMessage(BLACK_LOG, "sending vend session end request").sendToTarget();
                                        isReadEnd = true;
                                        isWriteEnd = true;
                                    }
                                }
                            }
                            if (sp.startsWith("01 01") && !isReadSetupPrice) {
                                isReadConfig = true;
                                //0011012b5c000aa3
                                byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x11, 0x01, 0x2B, 0x5C, 0x00, 0x0A, (byte) 0xA3});
                                if(isWriteSetupPrice){
                                    writeData(createPollBytes());
                                }else if (writeData(wbytes)) {
                                    handler.obtainMessage(BLACK_LOG, "sending setup max/mix price request").sendToTarget();
                                    isReadSetupPrice = true;
                                    isWriteSetupPrice = true;
                                }
                            }
                            if (sp.startsWith("01 09") && !isReadEnableReader) {
                                isReadExpansionId = true;
                                //00140115
                                byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x14, 0x01, 0x15});
                                if(isWriteEnableReader){
                                    writeData(createPollBytes());
                                }else if (writeData(wbytes)) {
                                    handler.obtainMessage(BLACK_LOG, "sending enable Reader request").sendToTarget();
                                    isReadEnableReader = true;
                                    isWriteEnableReader = true;
                                }
                            }
                            if (sp.startsWith("01 05") && !isReadVendDispatch) {
                                isReadVendApproved = true;
                                //00130200e1f6
                                byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x13, 0x02, 0x00, (byte) 0xE1, (byte) 0xF6});
                                if(isWriteVendDispatch){
                                    writeData(createPollBytes());
                                }else if (writeData(wbytes)) {
                                    handler.obtainMessage(BLACK_LOG, "sending vend dispatch request with item 00e1").sendToTarget();
                                    isReadVendDispatch = true;
                                    isWriteVendDispatch = true;
                                }
                            }
                            if (sp.startsWith("01 06")) {
                                byte[] wbytes = MDBUtils.mergePacket(0, new byte[]{0x13, 0x04, 0x17});
                                if(isWriteEnd){
                                    writeData(createPollBytes());
                                }else if (writeData(wbytes)) {
                                    handler.obtainMessage(BLACK_LOG, "vend denied!! sending vend session end request").sendToTarget();
                                    isReadEnd = true;
                                    isWriteEnd = true;
                                }
                            }
                            if (sp.startsWith("01 07")) {
                                flagEnd = false;
                            }
                        }else if(!isPolled){
                            if(writeData(createPollBytes())){
                                isPolled = true;
                            }
                        } else if (readResult.length == -262254) {
                            handler.obtainMessage(RED_LOG, "串口读取超时").sendToTarget();
                        } else {
                            handler.obtainMessage(RED_LOG, "串口读取失败 = " + readResult.length).sendToTarget();
                            Log.d(TAG, "read fail!!");
                        }
                    }
                }
                else {
                    Log.e(TAG, "write failed!! write data = " + ByteConvertStringUtil.buf2StringCompact(resetRequest));
                }
            }
        }).start();
    }

    /**
     * 1. test mib
     * send command to serial "Hardware diagnostic test":
     * Eg：
     * Send Data:090300946c0d
     * Recv Data: 09040194006b0d
     * Ps： ifCMDID（0x94）后面的ACK 不为0x00 ，说明MDB 通讯timeout
     * 2.get MIB version
     * send get version cmd
     * Send Data: 090300926e0d
     * Recv Data: 090601920000 0d 600d
     */
/*
    void testMdb() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                open();
                byte[] bytes = {0x09, 0x03, 0x00, (byte) 0x94, (byte) 0x6C, (byte) 0x0D};
                int write = aaa.write(bytes, 0, bytes.length);
                if (write >= 0) {
                    handler.obtainMessage(BLACK_LOG, "testing").sendToTarget();
                    byte[] resulta = new byte[16];
                    int read = aaa.read(resulta, resulta.length, 3000);
                    if (read >= 0) {
                        String bytes2Str = ByteConvertStringUtil.buf2StringCompact(subByteArray(resulta, read));
                        if (bytes2Str.startsWith("[09 04 01 94 00")) {
                            handler.obtainMessage(BLACK_LOG, "read ok: " + bytes2Str).sendToTarget();
                            handler.obtainMessage(GREEN_LOG, "test ok").sendToTarget();
                        } else {
                            handler.obtainMessage(RED_LOG, "MDB read timeout! " + bytes2Str).sendToTarget();
                            handler.obtainMessage(RED_LOG, "test failed!").sendToTarget();
                        }
                    } else if (read == -262254) {
                        handler.obtainMessage(RED_LOG, "serialport read timeout").sendToTarget();
                    } else {
                        handler.obtainMessage(RED_LOG, "serialport read failed").sendToTarget();
                    }
                }
                close();
            }
        }).start();
    }
*/
    @Override
    protected void onDestroy() {
        super.onDestroy();
        close();
    }

    //09 06 01 92 00 00 0E 5F 0D
    /*
    void getVersion() {
//        open();
//        new Thread(new Runnable() {
//            @Override
//            public void run() {
        byte[] bytes = {0x09, 0x03, 0x00, (byte) 0x92, (byte) 0x6E, (byte) 0x0D};
        int write = aaa.write(bytes, 0, bytes.length);
        handler.obtainMessage(BLACK_LOG, "Getting version, wait " + write).sendToTarget();
        if (write >= 0) {
            byte[] resulta = new byte[16];
            int read = aaa.read(resulta, resulta.length, 100);
            if (read >= 0) {
                String bytes2Str = ByteConvertStringUtil.buf2StringCompact(subByteArray(resulta, read));
                handler.obtainMessage(BLACK_LOG, "get result:" + bytes2Str).sendToTarget();
                printVersionName(bytes2Str);
            } else if (read == -262254) {
                handler.obtainMessage(RED_LOG, "serialport read timeout").sendToTarget();
            } else {
                handler.obtainMessage(RED_LOG, "serialport read failed").sendToTarget();
            }
        }
//            }
//        }).start();
//        close();
    }
*/
    //e.g. version 0019: sp == 01 92 00 00 13 5A, 00 13 decides 19
    public void printVersionName(String sp){
        int high = Integer.parseInt(sp.substring(9, 11), 16);
        int low = Integer.parseInt(sp.substring(12, 14), 16);
        int versionNo = high << 8 | low;
        currentVersion = String.valueOf(versionNo);
        handler.obtainMessage(GREEN_LOG, "version = " + currentVersion).sendToTarget();
    }
/*
    void testSend(byte[] bytes) {
        open();
        int write = aaa.write(bytes, 0, bytes.length);
        if (write >= 0) {
            handler.obtainMessage(BLACK_LOG, "write ok, result=" + write).sendToTarget();
            byte[] resulta = new byte[16];
            int read = aaa.read(resulta, resulta.length, 3000);
            if (read >= 0) {
                String bytes2Str = ByteConvertStringUtil.buf2StringCompact(subByteArray(resulta, read));
                handler.obtainMessage(BLACK_LOG, "read ok:\n" + bytes2Str).sendToTarget();
            } else if (read == -262254) {
                handler.obtainMessage(RED_LOG, "serialport read timeout").sendToTarget();
            } else {
                handler.obtainMessage(RED_LOG, "serialport read failed").sendToTarget();
            }
        }
        close();
    }
*/
    private Card rfCard;
    private RFCardReaderDevice rfCardReaderDevice = null;
    private SmartCardReaderDevice smartCardReaderDevice = null;

    @Override
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.open:
                open();
                break;
            case R.id.close:
                close();
                break;
            case R.id.btn_get_version:
//                textView.setText("");
                sendVersionRequest();
                disableAllButton();
                break;
            case R.id.btn_download_fw:
                textView.setText(getTimeWithFormat() + "\n");
                disableAllButton();
//                isSlave = true;
//                testMdbSlaveRead();
                break;
            case R.id.btn_test_send:
                byte[] bytes = createBytes(input.getText().toString());
//                testSend(bytes);
                break;
//			case R.id.btn_start:
//                if(isSlave){
//                    handler.obtainMessage(BLACK_LOG, "ERR!! The current mode is slave. " +
//                            "Please re-download master firmware(WhiteDemon_Master.bin)").sendToTarget();
//                }else {
//                    testMdbMasterSend();
//                }
//				break;
            case R.id.btn_trigger_pulse:

                break;
            case R.id.btn_set_pulse:
                disableAllButton();
                setPulse();
                break;
            case R.id.btn_setting:
                settingDialog = new SettingDialog(MainActivity.this,"setting", this);
                settingDialog.show();
                break;
        }
    }

    private void disableAllButton(){
        btnGetVersion.setEnabled(false);
        btnDownloadFw.setEnabled(false);
        btnSetting.setEnabled(false);
    }

    private void enableAllButton(){
        btnGetVersion.setEnabled(true);
        btnDownloadFw.setEnabled(true);
        btnSetting.setEnabled(true);
    }

	//可以添加参数 byte[] contentBytes
    private byte[] createBytes(){
        int lrc;
        byte[] contentBytes = {0x00, 0x10, 0x10};
        lrc = LRCCheckInt(contentBytes);
        byte[] dataBytes = {0x09, 0x04, 0x00, 0x10, 0x10, (byte) lrc, (byte) 0x0D};
        return dataBytes;
    }

    private byte[] createPollBytes(){
        int lrc;
        byte[] contentBytes = {0x00, 0x12, 0x12};
        lrc = LRCCheckInt(contentBytes);
        byte[] dataBytes = {0x09, 0x04, 0x00, 0x12, 0x12, (byte) lrc, (byte) 0x0D};
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        return dataBytes;
    }

    private boolean writeData(byte[] data){
        boolean ret = false;
        try {
            device.write(data, 0, data.length);
        } catch (DeviceException e) {
			throw new RuntimeException(e);
		}
		if(Arrays.equals(data, createPollBytes())){
            Log.d(TAG, "polling ...");
        } else{
            Log.d(TAG, "write data success! write length : " + data.length + "data : " + ByteConvertStringUtil.buf2StringCompact(data));
            ret = true;
        }
        return ret;
    }
    boolean isDownload;

    Thread downloadTh;


    byte[] readSDfile(String sdcard_mib_path) {
        File file = new File(sdcard_mib_path);
        try {
            FileInputStream fis = new FileInputStream(file);
            int ch = 0;
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            while ((ch = fis.read()) != -1) {
                baos.write(ch);
            }
            baos.flush();
            baos.close();
            fis.close();
            return baos.toByteArray();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    ArrayList<String> assetFiles = new ArrayList<>();

    private void listAssets() {
        String[] list = new String[0];
        try {
            list = getAssets().list("");
        } catch (IOException e) {
            e.printStackTrace();
        }
        for (String fileName : list) {
            if (fileName.endsWith(".bin")) {//fileName.startsWith("mib") &&
//                Log.d(TAG, "assetFile=" + fileName);
                assetFiles.add(fileName);
            }
        }
    }

    private String getBinName(){
        listAssets();
        String file_name;
        switch (spnItemWhiteDemon){
            case "0014":
                file_name = "WhiteDemon_0014.bin";
                break;
            case "0015":
                file_name = "WhiteDemon_0015.bin";
                break;
            case "0017":
                file_name = "WhiteDemon_0017.bin";
                break;
            case "0018":
                file_name = "WhiteDemon_0018.bin";
                break;
            case "0018_debug":
                file_name = "WhiteDemon_debug_0018.bin";
                break;
            case "0019":
                file_name = "WhiteDemon_0019.bin";
                break;
            default:
                file_name = null;
        }
        return file_name;
    }

    public byte[] toByteArray(String fname) throws IOException {
        InputStream fis = getAssets().open(fname);
        int ch = 0;
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        while ((ch = fis.read()) != -1) {
            baos.write(ch);
        }
        baos.flush();
        baos.close();
        fis.close();
        return baos.toByteArray();
    }

    public static byte[] subByteArray(byte[] byteArray, int length) {
        byte[] arrySub = new byte[length];
        for(int i = 0; i < length; i++){
            arrySub[i] = byteArray[i];
        }
        return arrySub;
    }

    public static byte[] subByteArrayIgnore(byte[] byteArray, int startIndex, int length) {
        int realLength = length - startIndex;
        byte[] arrySub = new byte[realLength];
        if (length >= 0) System.arraycopy(byteArray, startIndex, arrySub, 0, realLength);
        return arrySub;
    }

    private byte[] createBytes(String edit) {
        ArrayList<Byte> as = new ArrayList<>();

        int s1 = 9;
        int e1 = 13;

        int len;
        int lrc;
        String[] split = edit.replace(",", " ").split(" ");
        len = split.length + 1;
        for (String spli : split) {
            as.add((byte) Integer.parseInt(spli, 16));
        }
        byte[] by = new byte[as.size()];
        for (int i = 0; i < as.size(); i++) {
            by[i] = as.get(i);
        }
        lrc = LRCCheckInt(by);
        ArrayList<Byte> as2 = new ArrayList<>();

        as2.add((byte) s1);
        as2.add((byte) len);

        for (byte b : by) {
            as2.add(b);
        }

        as2.add((byte) lrc);
        as2.add((byte) e1);

        byte[] by2 = new byte[as2.size()];
        for (int i = 0; i < as2.size(); i++) {
//            Log.d("ByteConvertStringUtil.buf2StringCompact by2","as2.get(i)" +as2.get(i));
            by2[i] = as2.get(i);
        }

        String s = ByteConvertStringUtil.buf2StringCompact(by2);
        Log.d(TAG, "ss = " + s);
        return by2;
    }

    private int LRCCheckInt(byte[] bytes) {
        int l1 = 0;
        for (byte b : bytes) {
            l1 = l1 + (int) b;
        }
        return ~l1 + 1;
    }

    private String LRCCheck(byte[] bytes) {
        int l1 = 0;
        for (byte b : bytes) {
            l1 = l1 + (int) b;
        }
        return Integer.toHexString(~l1 + 1);
    }

    public static String getTimeWithFormat() {
        long time = System.currentTimeMillis();
        SimpleDateFormat sdr = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINA);
        return sdr.format(time);
    }

    public Handler handler = new Handler(new Handler.Callback() {
        @Override
        public boolean handleMessage(Message msg) {
            switch (msg.what) {
                case ENABLE_ALL_BUTTON:
                    enableAllButton();
                    break;
                case DISABLE_ALL_BUTTON:
                    disableAllButton();
                    break;
                case DISABLE_UPDATE_BUTTON:
                    btnDownloadFw.setEnabled(false);
                    break;
                case ENABLE_UPDATE_BUTTON:
                    btnDownloadFw.setEnabled(true);
                    break;
                case BLACK_LOG:
                    LogHelper.appendBlackMsg((String) msg.obj, textView);
                    break;
                case RED_LOG:
                    LogHelper.appendREDMsg((String) msg.obj, textView);
                    break;
                case GREEN_LOG:
                    LogHelper.appendGreenMsg((String) msg.obj, textView);
                    break;
                case 3:
                    float obj = (float) msg.obj;
                    progress.setProgress((int) obj);
                    progress_textView.setText(obj + "%");
                    break;
                case DIALOG_CONFIRM:
                    Item itemDialog = (Item)msg.obj;
                    AlertDialog dialog = new AlertDialog.Builder(MainActivity.this)
                            .setTitle("Please confirm item and amount")
                            .setMessage("Vend product\n " + "Amount: $" + itemDialog.getItemPrice() + ",Item: " + itemDialog.getItemId())
                            .setNegativeButton("Deny", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    sendVendDedied();
                                    dialog.dismiss();
                                }
                            })
                            .setPositiveButton("Approve", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    sendVendApproved(itemDialog);
                                    dialog.dismiss();
                                }
                            }).create();
                    dialog.show();
                    break;
                case DIALOG_ITEM:
                    AlertDialog dialog1 = new AlertDialog.Builder(MainActivity.this)
                            .setTitle("Dispense")
                            .setMessage(msg.obj + "")
                            .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    dialog.dismiss();
                                }
                            }).create();
                    dialog1.show();
                    break;
                case DIALOG_READCARD:
                    AlertDialog cardDialog = new AlertDialog.Builder(MainActivity.this)
                            .setTitle("Read card")
                            .setMessage("Please swipe card.")
                            .create();
                    cardDialog.show();
                    Item item = (Item)msg.obj;
                    Log.d(TAG, "Read item data " + item.getItemPrice() + "," + item.getItemId());

                    if (rfCardReaderDevice == null) {
                        rfCardReaderDevice = (RFCardReaderDevice) POSTerminal.getInstance(context)
                                .getDevice("cloudpos.device.rfcardreader");
                    }

                    if (smartCardReaderDevice == null) {
                        smartCardReaderDevice = (SmartCardReaderDevice) POSTerminal.getInstance(context)
                                .getDevice("cloudpos.device.smartcardreader");
                    }

                    try {
                        rfCardReaderDevice.open();
                        try {
                            OperationListener listener = new OperationListener() {

                                @Override
                                public void handleResult(OperationResult arg0) {

                                    try {
                                        if (arg0.getResultCode() == OperationResult.SUCCESS) {
                                            rfCard = ((RFCardReaderOperationResult) arg0).getCard();
                                            handler.obtainMessage(BLACK_LOG, "amount: $" + item.getItemPrice() + ",item: " + item.getItemId()).sendToTarget();
                                            handler.obtainMessage(DIALOG_CONFIRM, item).sendToTarget();
                                        } else {
                                            Log.d(TAG, "find_card_failed");
                                        }
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    } finally {
                                        try {
                                            rfCardReaderDevice.close();
                                            cardDialog.dismiss();
                                        } catch (DeviceException e) {
                                            e.printStackTrace();
                                        }
                                    }
                                }
                            };
                            rfCardReaderDevice.listenForCardPresent(listener, TimeConstants.FOREVER);
                        } catch (DeviceException e) {
                            e.printStackTrace();
                        }
                    } catch (DeviceException e) {
                        e.printStackTrace();
                    }
                    break;
            }
            return false;
        }
    });


    @Override
    public void onClickSetBalance() {
        settingDialog.dismiss();
    }

    @Override
    public void onClickTriggerPulse() {
        currentSend = 0;
        int frequency = getTriggerPulseFrequency();
        if(frequency < 0){
            settingDialog.dismiss();
            return;
        }
        settingDialog.setFrequency(frequency);
        int latency = getTriggerPulseLatency();
        if(latency < 0){
            settingDialog.dismiss();
            return;
        }
        settingDialog.setLatency(latency);
        sendVersionRequest();
        disableAllButton();
        SystemClock.sleep(500);
        if(currentVersion.equals("19")){
            sendTriggerPulse();
        }else{
            handler.obtainMessage(RED_LOG, "version is not 0019, trigger pulse failed, please update FW version").sendToTarget();
        }
        enableAllButton();
        settingDialog.dismiss();
    }

    @Override
    public void onClickSetPulse() {
        setPulse();
        settingDialog.dismiss();
    }

    public int getTriggerPulseFrequency(){
        int ret = -1;
        String sContent = settingDialog.getFrequency();
        if(sContent.trim().isEmpty()){
            return ret;
        }
        try{
            ret = Integer.parseInt(sContent);
        }catch(Exception e){
            Log.e(TAG, "frequency must be a number");
            handler.obtainMessage(RED_LOG, "frequency must be a number").sendToTarget();
            return ret;
        }
        if(ret < 0)
        {
            Log.e(TAG, "frequency must be greater than 0");
            handler.obtainMessage(RED_LOG, "frequency must be greater than 0").sendToTarget();
            return ret;
        }
        return ret;
//        return 5;
    }
    public int getTriggerPulseLatency(){
        int ret = 0;
        String sContent = settingDialog.getLatency();
        if(sContent.trim().isEmpty()){
            return ret;
        }
        try{
            ret = Integer.parseInt(sContent);
        }catch(Exception e){
            Log.e(TAG, "latency must be a number");
            handler.obtainMessage(RED_LOG, "latency must be a number").sendToTarget();
            return ret;
        }
        if(ret <= 0)
        {
            Log.e(TAG, "latency must be greater than 0");
            handler.obtainMessage(RED_LOG, "latency must be greater than 0").sendToTarget();
            return ret;
        }
        return ret;
//        return 200;
    }

    public int getPulseDuration(){
        int ret = -1;
        String sContent = settingDialog.getDuration();
        if(sContent.trim().isEmpty()){
            return ret;
        }
        try{
            ret = Integer.parseInt(sContent);
        }catch(Exception e){
            Log.e(TAG, "duration value must be a number");
            handler.obtainMessage(RED_LOG, "duration value must be a number").sendToTarget();
            return ret;
        }
        if(ret < 10 || ret > 200){
            handler.obtainMessage(RED_LOG, "error: duration value range: 10~200").sendToTarget();
            return ret;
        }
        return ret;
    }

    public int getBalance(){
        int ret = -1;
        String sContent = settingDialog.getBalance();
        if(sContent.trim().isEmpty()){
            return ret;
        }
        try{
            ret = Integer.parseInt(sContent);
        }catch(Exception e){
            Log.e(TAG, "balance value must be a number");
            handler.obtainMessage(RED_LOG, "balance value must be a number").sendToTarget();
            return ret;
        }
        if(ret < 0 || ret > 65535){
            Log.e(TAG, "error: balance value range: 0~65535");
            handler.obtainMessage(RED_LOG, "error: balance value range: 0~65535").sendToTarget();
            return ret;
        }
        return ret;
    }

}