package com.wizarpos.mdbtest;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public class SettingDialog extends Dialog {

	private String mTitle;
	private OnDialogClickListener mListener;

	public Button btnTriggerPulse, btnSetPulse, btnSetBalance, btnCancel;
	public EditText etDuration, etFrequency, etBalance, etLatency;
	public Spinner spnVoltage;

	private String balance, frequency, latency, duration;

	private String spnItemVoltage;
	private static final String TAG = "MDB TAG Setting Dialog";

	public SettingDialog(Context context,  String title, OnDialogClickListener listener){
		super(context);
		mTitle = title;
		mListener = listener;
		balance = "-1";
		frequency = "-1";
		latency = "-1";
		duration = "-1";
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.layout_setting_dialog);

		btnTriggerPulse = findViewById(R.id.btn_trigger_pulse);
		btnSetPulse = findViewById(R.id.btn_set_pulse);
		btnSetBalance = findViewById(R.id.btn_set_balance);
		btnCancel = findViewById(R.id.btn_cancel);

		etDuration = findViewById(R.id.et_duration);
		etFrequency = findViewById(R.id.et_frequency);
		etBalance = findViewById(R.id.et_balance);
		etLatency = findViewById(R.id.et_latency);

		spnVoltage = findViewById(R.id.spn_voltage);

		ArrayAdapter<CharSequence> adapterVoltage = ArrayAdapter.createFromResource(this.getContext(),
				R.array.spn_voltage, android.R.layout.simple_spinner_item);
		adapterVoltage.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spnVoltage.setAdapter(adapterVoltage);
		spnVoltage.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
				spnItemVoltage = spnVoltage.getSelectedItem().toString();
			}
			@Override
			public void onNothingSelected(AdapterView<?> adapterView) {

			}
		});

		btnTriggerPulse.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				mListener.onClickTriggerPulse();
			}
		});
		btnSetPulse.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				mListener.onClickSetPulse();
			}
		});
		btnSetBalance.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				mListener.onClickSetBalance();
			}
		});
		btnCancel.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				dismiss();
			}
		});
	}

	public String getBalance() {
		balance = etBalance.getText().toString();
		return balance;
	}

	public void setBalance(String balance){
		this.balance = balance;
	}


	public int getVoltage(){
		return Integer.parseInt(spnItemVoltage);
	}

	public String getDuration() {
		duration = etDuration.getText().toString();
		return duration;
	}

	public String getLatency() {
		latency = etLatency.getText().toString();
		return latency;
	}

	public void setLatency(int latency) {
		this.latency = String.valueOf(latency);
	}

	public String getFrequency() {
		frequency = etFrequency.getText().toString();
		return frequency;
	}

	public void setFrequency(int frequency) {
		this.latency = String.valueOf(frequency);
	}

	public interface OnDialogClickListener{
		void onClickSetBalance();
		void onClickTriggerPulse();
		void onClickSetPulse();
	}
}
